using UnityEngine;

namespace Overdash.Combat.Projectiles
{
    public class RicochetProjectile : ProjectileBase
    {
        [SerializeField] private int ricochetCount;

        protected override void WallHit(Collision2D collision)
        {
            ricochetCount--;
            GetComponent<AudioSource>().PlayOneShot(wallHitSound);
            
            if (ricochetCount < 0)
                Deactivate();
            else
                transform.up = Vector2.Reflect(transform.up, collision.GetContact(0).normal);
            
        }
    }
}
