using UnityEngine;

namespace Overdash.Combat.Projectiles
{
    public class WobblyProjectile : ProjectileBase
    {
        [SerializeField] private float wobbleFrequency;
        [SerializeField] private float wobbleAmplitude;
        protected override void Update()
        {
            if (isActive)
            {   
                //rotation along the curve would be also nice, cannot figure it out
                rigidbody.velocity =  Quaternion.Euler(0, 0, Mathf.Sin(Time.time * wobbleFrequency) * wobbleAmplitude) * transform.up * ammoType.projectileSpeed;
            } 
        }
    }
}