using UnityEngine;

namespace Overdash.General
{
    [RequireComponent(typeof(Camera), typeof(BoxCollider2D))]
    public class ScreenBounds  : MonoBehaviour
    {
        private Vector2 screenSize;
    
        private void Start()
        {
            var camera = GetComponent<Camera>();
            screenSize = new Vector2(camera.orthographicSize * 2 * camera.aspect, camera.orthographicSize * 2);
            GetComponent<BoxCollider2D>().size = screenSize;
        }

        private void OnTriggerExit2D(Collider2D o)
        {
            //if (Mathf.Abs(o.transform.position.x) > screenSize.x / 2)
            //    o.transform.position *= new Vector2(-1, 1);
            //if (Mathf.Abs(o.transform.position.y) > screenSize.y / 2)
            //    o.transform.position *= new Vector2(1, -1);
        
            if (o.transform.position.x > screenSize.x / 2) o.transform.position -= new Vector3(screenSize.x, 0, 0);
            if (o.transform.position.x < -screenSize.x / 2) o.transform.position += new Vector3(screenSize.x, 0, 0);
            if (o.transform.position.y > screenSize.y / 2) o.transform.position -= new Vector3(0, screenSize.y, 0);
            if (o.transform.position.y < -screenSize.y / 2) o.transform.position += new Vector3(0, screenSize.y, 0);
        }
    }
}