﻿using System.Collections.Generic;
using Overdash.Common;
using UnityEngine;

namespace Overdash.Global
{
    public class PropsManager : MonoBehaviourSingleton<PropsManager>
    {
        public static readonly List<GameObject> PropsList = new ();
       
        protected override void Awake()
        {
            base.Awake();
            RoundLoop.OnRoundEnd += ClearProps;
        }
        
        private static void ClearProps()
        {
            foreach (var prop in PropsList)
                Destroy(prop);
            PropsList.Clear();
        }
    }
}