﻿using System;
using System.Collections.Generic;
using Overdash.Player;
using UnityEngine;

namespace Overdash.Global
{
    public static class Scoreboard
    {
        // Events
        public static event Action<Player.Player> OnPlayerScored;
        public static event Action<Player.Player> OnPlayerLostPoint;
        
        public static readonly Dictionary<Player.Player, int> Score;
        
        static Scoreboard()
        {
            Debug.Log("Scoreboard initialized");
            Score = new Dictionary<Player.Player, int>();
            PlayerManager.OnPlayerJoined += 
                player => Score.Add(player, 0);
        }
        
        public static void AddPoint(Player.Player player)
        {
            Score[player]++;
            OnPlayerScored?.Invoke(player);
        }
        
        public static void RemovePoint(Player.Player player)
        {
            Score[player] = Mathf.Max(Score[player] - 1, 0);
            OnPlayerLostPoint?.Invoke(player);
        }
    }
}