using System.Linq;
using Overdash.Global;
using TMPro;
using UnityEngine;
using UnityEngine.Serialization;

namespace Overdash.UI
{
    public class PlayerScoreUI : MonoBehaviour
    {
        [SerializeField] private TextMeshProUGUI numberText;
        [SerializeField] private TextMeshProUGUI scoreText;
        
        private int score;

        public void SetPlayer(Player.Player player)
        {
            numberText.color = player.color;
            numberText.text = $"P{player.number}";
            SetScore(0);
        }
        
        public void SetScore(int newScore)
        {
            this.score = Mathf.Max(0, newScore);
            scoreText.text = string.Concat(Enumerable.Repeat("X ", score));
        }

        public int GetScore()
        {
            return this.score;
        }

        public void AddPoint() => SetScore(score + 1);
        public void RemovePoint() => SetScore(score - 1);
    }
}