using System.Collections;
using Overdash.Global;
using TMPro;
using UnityEngine;

namespace Overdash.UI
{
    [RequireComponent(typeof(TextMeshProUGUI))]
    public class RoundModifierText : MonoBehaviour
    {
    
        private TextMeshProUGUI textComponent;
    
        private void Awake()
        {
            textComponent = GetComponent<TextMeshProUGUI>();
            RoundLoop.OnNewRound += () =>
            {
                if (RoundLoop.currentRoundModifier != null)
                    StartCoroutine(Display(RoundLoop.currentRoundModifier.label.ToUpper()));
            };
        }
    
        private IEnumerator Display(string text)
        {
            textComponent.text = text;
            textComponent.color = Color.yellow; // Color.white;
            yield return new WaitForSecondsRealtime(2f);
        
            const float fadeTime = 2f;
            for (var t = 0f; t < fadeTime; t += Time.unscaledDeltaTime)
            {
                textComponent.color = Color.Lerp(Color.yellow, Color.clear, t / fadeTime);
                yield return null;
            }
        }
    }
}
